<template>
  <div id="app">
    <block color="#ef5350">
      <text-field
        placeholder="Label"
        :value="pizza.label"
        @input="updatePizza({ label: $event.target.value })"
        :size="18"
        :editable="!locked"
      >{{ pizza.label }}</text-field>
    </block>
    <block :height="285" color="#ffca28">
      <div class="listview">
        <row v-for="(item, idx) in pizza.items" :key="idx">
          <radio slot="icon-cell" :handleClick="() => handleTakeOff(item)" />
          <text-field
            slot="left-cell"
            placeholder="Item"
            :value="item"
            @input="setItem(idx)($event)"
            :editable="!locked"
          >{{ item }}</text-field>
        </row>
        <row>
          <text-field
            slot="right-cell"
            type="number"
            placeholder="Price"
            :value="pizza.price"
            @input="updatePizza({ price: parseFloat($event.target.value) })"
            :editable="!locked"
          >{{ (pizza.price - takeOff.length).toFixed(2) }} €</text-field>
        </row>
      </div>
    </block>
    <block color="#ffa726">
      <hyper-link @click="locked = !locked" :size="18">{{ locked ? 'Unlock' : 'Lock' }}</hyper-link>
      <hyper-link @click="() => $router.history.push('/')" :size="18">Back</hyper-link>
      <hyper-link v-if="!locked" @click="removePizza" :size="18">Del</hyper-link>
    </block>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import { Block, Row, TextField, HyperLink, Radio } from '../layers';
// import { capitalize } from '@/utils';

export default {
  components: {
    Block,
    Row,
    TextField,
    HyperLink,
    Radio
  },
  computed: {
    ...mapGetters(['getPizzaById']),
    pizza() {
      return this.getPizzaById(this.$route.params.id);
    }
  },
  data() {
    return {
      takeOff: [],
      locked: true
    };
  },
  methods: {
    ...mapActions(['delPizza', 'setPizza']),
    handleTakeOff(item) {
      if (this.takeOff.find(i => i === item)) {
        this.takeOff = this.takeOff.filter(i => i !== item);
      } else {
        this.takeOff = [...this.takeOff, item];
      }
    },
    removePizza() {
      this.delPizza(this.$route.params.id);
      this.$router.history.push('/');
    },
    updatePizza(props) {
      this.setPizza({
        id: this.$route.params.id,
        ...props
      });
    },
    setItem(index) {
      const items = this.pizza.items;

      return event => {
        items[index] = event.target.value;
        this.updatePizza({ items });
      };
    }
  }
};
</script>

<style lang="scss">
#app {
  display: flex;
  flex-direction: column;
  justify-content: center;
  height: 90vh;

  > div {
    margin: 10px auto;
    width: 310px;
  }
}

.listview {
  display: flex;
  flex-direction: column;
  height: calc(100% - 10px);
  overflow-y: scroll;
  padding-bottom: 5px;
  margin: 0 auto;
  z-index: 2;
}
</style>
